package de.onyxbits.scenehaul;
import com.threerings.io.ObjectInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import com.threerings.piracy.data.YoSceneModel;
import com.threerings.miso.*;
import com.threerings.whirled.data.*;
import com.threerings.miso.data.*;
import com.threerings.miso.tools.xml.*;
import com.megginson.sax.*;
import com.threerings.stage.tools.xml.*;
import javax.swing.*;

public class SceneHaul extends JFrame {

  public static final File scenedir = new File("scenes");
  public static final File scenedir_xml = new File("scenes_xml");
  
  private JTextArea txt = new JTextArea(25,80);
  
  public SceneHaul() {
    super("SceneHaul - v1.3");
    txt.setEditable(false);
    getContentPane().add(new JScrollPane(txt));
    pack(); 
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }
  
  public void process() throws Exception {
    if (!scenedir.exists()) {
      //Freak out!
      txt.setText("I think, we are not in Kansas any more!");
      return;
    }
    
    txt.setText("CONVERTING:\n\n");
    
    File oceans[] = scenedir.listFiles();
    scenedir_xml.mkdirs();
    for (File ocean:oceans) {
      File destdir = new File(scenedir_xml,ocean.getName());
      destdir.mkdirs();
      File scenes[] = ocean.listFiles();
      for (File scene:scenes) {
        if (!scene.getName().matches("[0-9]*")) continue;
        
        try {
          txt.append(scene.getCanonicalPath());
          InputStream ins = new FileInputStream(scene);
          ObjectInputStream ois = new ObjectInputStream(ins);
          YoSceneModel yoSceneModel = (YoSceneModel)ois.readObject();
          File destfile = new File(destdir,scene.getName()+"_"+yoSceneModel.name+".xml");
          StageSceneWriter ssw = new StageSceneWriter();
          ssw.writeScene(destfile,yoSceneModel);
          txt.append("\t-> "+yoSceneModel.name+"\n");
        }
        catch (Exception e) {
          // Likely non fatal.
          txt.append("\tIGNORED\n");
          e.printStackTrace();
        }
      }
    }
    txt.append("\nFINISHED");
  }
  
  
  public static void main(String args[]) throws Exception {
    SceneHaul sc = new SceneHaul();
    sc.setVisible(true);
    sc.process();
  }
}